#include "PCH.h"

#include "InputMgrImpl.h"

namespace{
const char* BUTTON_NAME[] = {
	"-",

	"K_0", "K_1", "K_2", "K_3", "K_4", "K_5", "K_6", "K_7", "K_8", "K_9",
	"K_A", "K_B", "K_C", "K_D", "K_E", "K_F", "K_G", "K_H", "K_I", "K_J", "K_K", "K_", "K_M", "K_N",
	"K_O", "K_P", "K_Q", "K_R", "K_S", "K_T", "K_U", "K_V", "K_W", "K_X", "K_Y", "K_Z",
	"K_LEFT", "K_RIGHT", "K_UP", "K_DOWN",
	"K_ENTER", "K_ESC", "K_SPACE", "K_TAB",
	"K_SHIFT", "K_LSHIFT", "K_RSHIFT",
	"K_CTRL", "K_LCTRL", "K_RCTRL",
	"K_ALT", "K_LALT", "K_RALT",
	"K_NUM0", "K_NUM1", "K_NUM2", "K_NUM3", "K_NUM4", "K_NUM5", "K_NUM6", "K_NUM7", "K_NUM8", "K_NUM9",
	"K_NUMPLUS", "K_NUMMINUS", "K_NUMSTAR", "K_NUMSLASH", "K_NUMDOT", "K_NUMENTER",
	"K_F1" , "K_F2" , "K_F3" , "K_F4" , "K_F5" , "K_F6" , "K_F7" , "K_F8" , "K_F9" , "K_F10", "K_F11", "K_F12",
	"K_F13", "K_F14", "K_F15", "K_F16", "K_F17", "K_F18", "K_F19", "K_F20", "K_F21", "K_F22", "K_F23", "K_F24",

	"J1_LEFT", "J1_RIGHT", "J1_UP", "J1_DOWN",
	"J1_BTN1", "J1_BTN2" , "J1_BTN3" , "J1_BTN4" , "J1_BTN5" , "J1_BTN6" , "J1_BTN7" , "J1_BTN8" ,
	"J1_BTN9", "J1_BTN10", "J1_BTN11", "J1_BTN12", "J1_BTN13", "J1_BTN14", "J1_BTN15", "J1_BTN16",
	"J2_LEFT", "J2_RIGHT", "J2_UP", "J2_DOWN",
	"J2_BTN1", "J2_BTN2" , "J2_BTN3" , "J2_BTN4" , "J2_BTN5" , "J2_BTN6" , "J2_BTN7" , "J2_BTN8" ,
	"J2_BTN9", "J2_BTN10", "J2_BTN11", "J2_BTN12", "J2_BTN13", "J2_BTN14", "J2_BTN15", "J2_BTN16",

	"VC1_LEFT", "VC1_RIGHT", "VC1_UP", "VC1_DOWN",
	"VC1_BTN1", "VC1_BTN2" , "VC1_BTN3" , "VC1_BTN4" , "VC1_BTN5" , "VC1_BTN6" , "VC1_BTN7" , "VC1_BTN8" ,
	"VC1_BTN9", "VC1_BTN10", "VC1_BTN11", "VC1_BTN12", "VC1_BTN13", "VC1_BTN14", "VC1_BTN15", "VC1_BTN16",
	"VC2_LEFT", "VC2_RIGHT", "VC2_UP", "VC2_DOWN",
	"VC2_BTN1", "VC2_BTN2" , "VC2_BTN3" , "VC2_BTN4" , "VC2_BTN5" , "VC2_BTN6" , "VC2_BTN7" , "VC2_BTN8" ,
	"VC2_BTN9", "VC2_BTN10", "VC2_BTN11", "VC2_BTN12", "VC2_BTN13", "VC2_BTN14", "VC2_BTN15", "VC2_BTN16"
};
}
//========================================================================
const char* UQ::InputMgrImpl::getButtonName(ButtonID buttonID)
{
	return BUTTON_NAME[buttonID];
}

//========================================================================
UQ::InputMgrImpl::InputMgrImpl()
{
	memset(isDown_, false, sizeof(isDown_));
	memset(isDownPrev_, false, sizeof(isDownPrev_));
	memset(assign_, ID_DISABLE, sizeof(assign_));
	for(int i = 0; i < VC_COUNT_ * (VC2_BTN1 - VC1_BTN1); i++){
		strcpy(assignName_[i], "");
	}
	memset(pJoystick_, 0, sizeof(pJoystick_));

	for(int i = 0; i < J_COUNT_; i++){
		if(SDL_NumJoysticks() > i) pJoystick_[i] = SDL_JoystickOpen(i);
	}

	for(int i = 0; i < VC_COUNT_ * (VC2_BTN1 - VC1_BTN1); i++){for(int j = 0; j < ASSIGN_COUNT_; j++){
		assign_[i][j] = static_cast<ButtonID>(std::atoi(iniFile.GetKeyValue("Input", makeString("%s_%d", BUTTON_NAME[i + VC1_LEFT], j), "0").c_str()));
	}}
}

//========================================================================
UQ::InputMgrImpl::~InputMgrImpl()
{
	for(int i = 0; i < VC_COUNT_ * (VC2_BTN1 - VC1_BTN1); i++){for(int j = 0; j < ASSIGN_COUNT_; j++){
		iniFile.SetKeyValue("Input", makeString("%s_%d", BUTTON_NAME[i + VC1_LEFT], j), makeString("%d", (int)assign_[i][j]));
	}}
	for(int i = 0; i < J_COUNT_; i++){
		if(SDL_JoystickOpened(i)) SDL_JoystickClose(pJoystick_[i]);
	}
	SDL_QuitSubSystem(SDL_INIT_JOYSTICK);
}

//========================================================================
void UQ::InputMgrImpl::update(void)
{
	memcpy(isDownPrev_, isDown_, sizeof(isDown_));
	memset(isDown_, false, sizeof(isDown_));

	// L[{[h
	const int KEY_MAP[] = {
		//       0           1           2           3           4           5           6           7           8           9
		ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, K_TAB     , // 000
		ID_DISABLE, ID_DISABLE, ID_DISABLE, K_ENTER   , ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, // 010
		ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, K_ESC     , ID_DISABLE, ID_DISABLE, // 020
		ID_DISABLE, ID_DISABLE, K_SPACE   , ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, // 030
		ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, K_0       , K_1       , // 040
		K_2       , K_3       , K_4       , K_5       , K_6       , K_7       , K_8       , K_9       , ID_DISABLE, ID_DISABLE, // 050
		ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, // 060
		ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, // 070
		ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, // 080
		ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, K_A       , K_B       , K_C       , // 090
		K_D       , K_E       , K_F       , K_G       , K_H       , K_I       , K_J       , K_K       , K_L       , K_M       , // 100
		K_N       , K_O       , K_P       , K_Q       , K_R       , K_S       , K_T       , K_U       , K_V       , K_W       , // 110
		K_X       , K_Y       , K_Z       , ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, // 120
		ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, // 130
		ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, // 140
		ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, // 150
		ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, // 160
		ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, // 170
		ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, // 180
		ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, // 190
		ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, // 200
		ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, // 210
		ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, // 220
		ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, // 230
		ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, // 240
		ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, ID_DISABLE, K_NUM0    , K_NUM1    , K_NUM2    , K_NUM3    , // 250
		K_NUM4    , K_NUM5    , K_NUM6    , K_NUM7    , K_NUM8    , K_NUM9    , K_NUMDOT  , K_NUMSLASH, K_NUMSTAR , K_NUMMINUS, // 260
		K_NUMPLUS , K_NUMENTER, ID_DISABLE, K_UP      , K_DOWN    , K_RIGHT   , K_LEFT    , ID_DISABLE, ID_DISABLE, ID_DISABLE, // 270
		ID_DISABLE, ID_DISABLE, K_F1      , K_F2      , K_F3      , K_F4      , K_F5      , K_F6      , K_F7      , K_F8      , // 280
		K_F9      , K_F10     , K_F11     , K_F12     , K_F13     , K_F14     , K_F15     , ID_DISABLE, ID_DISABLE, ID_DISABLE, // 290
		ID_DISABLE, ID_DISABLE, ID_DISABLE, K_RSHIFT  , K_LSHIFT  , K_RCTRL   , K_LCTRL   , K_RALT    , K_LALT    , ID_DISABLE  // 300
	};
	Uint8 *keys = SDL_GetKeyState(nullptr);
	for(int i = 0; i < sizeof(KEY_MAP) / sizeof(int); i++){
		if(keys[i] == SDL_PRESSED) isDown_[KEY_MAP[i]] = true;
	}
	isDown_[ID_DISABLE] = false;

	// WCpbh
	SDL_JoystickUpdate();
	for(int i = 0; i < J_COUNT_; i++){
		if(pJoystick_[i]){
			for(int j = 1; j <= J_BTN_COUNT_; j++){
				if(SDL_JoystickGetButton(pJoystick_[i], j) == SDL_PRESSED) isDown_[J_BTN(i + 1, j)] = true;
			}
			static const Sint16 CENTER = 0;
			static const Sint16 THRESHOLD = 1000;
			Sint16 x = SDL_JoystickGetAxis(pJoystick_[i], 0);
			Sint16 y = SDL_JoystickGetAxis(pJoystick_[i], 1);
			if(x > CENTER + THRESHOLD) isDown_[J_RIGHT(i + 1)] = true;
			if(y > CENTER + THRESHOLD) isDown_[J_DOWN(i + 1) ] = true;
			if(x < CENTER - THRESHOLD) isDown_[J_LEFT(i + 1) ] = true;
			if(y < CENTER - THRESHOLD) isDown_[J_UP(i + 1)   ] = true;
		}
	}

	// zRg[
	for(int i = 0; i < VC_COUNT_ * (VC2_BTN1 - VC1_BTN1); i++){
		for(int j = 0; j < ASSIGN_COUNT_; j++){
			isDown_[i + VC1_LEFT] |= isDown_[ assign_[i][j] ];
		}
	}
}

//========================================================================
void UQ::InputMgrImpl::assign(
	ButtonID vcButtonID, const char* assignName,
	ButtonID assign1, ButtonID assign2, ButtonID assign3, ButtonID assign4
	)
{
	ButtonID assign[ASSIGN_COUNT_] = {assign1, assign2, assign3, assign4};

	MY_ASSERT_EXPR(vcButtonID >= VC1_LEFT, "vcButtonID słB");
	for(int i = 0; i < ASSIGN_COUNT_; i++){
		MY_ASSERT_EXPR(assign[i] < VC1_LEFT, "assign1 - assign4 słB");
	}

	strcpy(assignName_[vcButtonID - VC1_LEFT], assignName);
	for(int i = 0; i < ASSIGN_COUNT_; i++){
		if(assign_[vcButtonID - VC1_LEFT][i] == ID_DISABLE) assign_[vcButtonID - VC1_LEFT][i] = assign[i];
	}
}

//========================================================================
UQ::InputMgr::ButtonID UQ::InputMgrImpl::J_BTN(int padNo, int buttonNo) const
{
	MY_ASSERT_EXPR(padNo >= 1 && padNo <= J_COUNT_, "Rg[ԍsłB");
	MY_ASSERT_EXPR(buttonNo >= 1 && buttonNo <= J_BTN_COUNT_, "{^ԍsłB");
	return static_cast<ButtonID>(J1_BTN1 + (padNo - 1) * (J2_BTN1 - J1_BTN1) + (buttonNo - 1));
}
UQ::InputMgr::ButtonID UQ::InputMgrImpl::J_UP(int padNo) const
{
	MY_ASSERT_EXPR(padNo >= 1 && padNo <= J_COUNT_, "Rg[ԍsłB");
	return static_cast<ButtonID>(J1_UP + (padNo - 1) * (J2_BTN1 - J1_BTN1));
}
UQ::InputMgr::ButtonID UQ::InputMgrImpl::J_DOWN(int padNo) const
{
	MY_ASSERT_EXPR(padNo >= 1 && padNo <= J_COUNT_, "Rg[ԍsłB");
	return static_cast<ButtonID>(J1_DOWN + (padNo - 1) * (J2_BTN1 - J1_BTN1));
}
UQ::InputMgr::ButtonID UQ::InputMgrImpl::J_LEFT(int padNo) const
{
	MY_ASSERT_EXPR(padNo >= 1 && padNo <= J_COUNT_, "Rg[ԍsłB");
	return static_cast<ButtonID>(J1_LEFT + (padNo - 1) * (J2_BTN1 - J1_BTN1));
}
UQ::InputMgr::ButtonID UQ::InputMgrImpl::J_RIGHT(int padNo) const
{
	MY_ASSERT_EXPR(padNo >= 1 && padNo <= J_COUNT_, "Rg[ԍsłB");
	return static_cast<ButtonID>(J1_RIGHT + (padNo - 1) * (J2_BTN1 - J1_BTN1));
}

//========================================================================
UQ::InputMgr::ButtonID UQ::InputMgrImpl::VC_BTN(int padNo, int buttonNo) const
{
	MY_ASSERT_EXPR(padNo >= 1 && padNo <= VC_COUNT_, "Rg[ԍsłB");
	MY_ASSERT_EXPR(buttonNo >= 1 && buttonNo <= VC_BTN_COUNT_, "{^ԍsłB");
	return static_cast<ButtonID>(VC1_BTN1 + (padNo - 1) * (VC2_BTN1 - VC1_BTN1) + (buttonNo - 1));
}
UQ::InputMgr::ButtonID UQ::InputMgrImpl::VC_UP(int padNo) const
{
	MY_ASSERT_EXPR(padNo >= 1 && padNo <= VC_COUNT_, "Rg[ԍsłB");
	return static_cast<ButtonID>(VC1_UP + (padNo - 1) * (VC2_BTN1 - VC1_BTN1));
}
UQ::InputMgr::ButtonID UQ::InputMgrImpl::VC_DOWN(int padNo) const
{
	MY_ASSERT_EXPR(padNo >= 1 && padNo <= VC_COUNT_, "Rg[ԍsłB");
	return static_cast<ButtonID>(VC1_DOWN + (padNo - 1) * (VC2_BTN1 - VC1_BTN1));
}
UQ::InputMgr::ButtonID UQ::InputMgrImpl::VC_LEFT(int padNo) const
{
	MY_ASSERT_EXPR(padNo >= 1 && padNo <= VC_COUNT_, "Rg[ԍsłB");
	return static_cast<ButtonID>(VC1_LEFT + (padNo - 1) * (VC2_BTN1 - VC1_BTN1));
}
UQ::InputMgr::ButtonID UQ::InputMgrImpl::VC_RIGHT(int padNo) const
{
	MY_ASSERT_EXPR(padNo >= 1 && padNo <= VC_COUNT_, "Rg[ԍsłB");
	return static_cast<ButtonID>(VC1_RIGHT + (padNo - 1) * (VC2_BTN1 - VC1_BTN1));
}

/*
//========================================================================
namespace{
BOOL CALLBACK DlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static UQ::InputMgrImpl* pInputMgr = 0;
	if(msg == WM_INITDIALOG) pInputMgr = (UQ::InputMgrImpl*)lParam;
	return pInputMgr->DlgProc(hDlg, msg, wParam, lParam);
}
}

//========================================================================
BOOL UQ::InputMgrImpl::DlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static const int SHOW_BUTTON_COUNT = 4;
	static const int STATIC_BTN_NAME[4 + SHOW_BUTTON_COUNT] = {
		STATIC_LEFT, STATIC_RIGHT, STATIC_UP, STATIC_DOWN,
		STATIC_1, STATIC_2, STATIC_3, STATIC_4
	};
	static const int STATIC_ASSIGN[4 + SHOW_BUTTON_COUNT][UQ::InputMgr::ASSIGN_COUNT_] = {
		{STATIC_LEFT_1 , STATIC_LEFT_2 , STATIC_LEFT_3 , STATIC_LEFT_4 },
		{STATIC_RIGHT_1, STATIC_RIGHT_2, STATIC_RIGHT_3, STATIC_RIGHT_4},
		{STATIC_UP_1   , STATIC_UP_2   , STATIC_UP_3   , STATIC_UP_4   },
		{STATIC_DOWN_1 , STATIC_DOWN_2 , STATIC_DOWN_3 , STATIC_DOWN_4 },
		{STATIC_1_1, STATIC_1_2, STATIC_1_3, STATIC_1_4},
		{STATIC_2_1, STATIC_2_2, STATIC_2_3, STATIC_2_4},
		{STATIC_3_1, STATIC_3_2, STATIC_3_3, STATIC_3_4},
		{STATIC_4_1, STATIC_4_2, STATIC_4_3, STATIC_4_4}
	};

	static const int BUTTON_DUMMY = 500; // tH[JXĂ
	static const int TIMER_PRESS = 501;
	static HBRUSH brushSelected = 0;
	static int selected = 0;

	switch(msg){
	case WM_INITDIALOG:
		isDialogEnd_ = false;
		RemoveMenu(GetSystemMenu(hDlg, 0), SC_CLOSE, MF_BYCOMMAND);
		CreateWindow("BUTTON", 0, WS_CHILD | WS_VISIBLE | BS_OWNERDRAW, 0, 0, 1, 1, hDlg, (HMENU)BUTTON_DUMMY, hInstance, 0);
		brushSelected = CreateSolidBrush(RGB(0, 0, 255));
		for(int i = 0; i < VC_COUNT_; i++){
			SendMessage(GetDlgItem(hDlg, COMBO_VC), CB_ADDSTRING, 0, (LPARAM)makeString("Virtual Controller %d", i + 1));
		}
		SendMessage(GetDlgItem(hDlg, COMBO_VC), CB_SETCURSEL, 0, 0);
		for(int i = 0; i < VC_BTN_COUNT_ / SHOW_BUTTON_COUNT; i++){
			TCITEM ti;
			ti.mask = TCIF_TEXT;
			ti.pszText = makeString("%d - %d", i * SHOW_BUTTON_COUNT + 1, (i + 1) * SHOW_BUTTON_COUNT);
			TabCtrl_InsertItem(GetDlgItem(hDlg, TAB_BUTTON), i, &ti);
		}
		SetFocus(GetDlgItem(hDlg, BUTTON_DUMMY));
		SetTimer(hDlg, TIMER_PRESS, 16, 0);
		return FALSE;

	case WM_TIMER:
		update();
		for(int k = VC1_LEFT - 1; k > ID_DISABLE; k--){
			if(isPressed(static_cast<ButtonID>(k))){
				int padNo = (int)SendMessage(GetDlgItem(hDlg, COMBO_VC), CB_GETCURSEL, 0, 0);
				int buttonTabNo = TabCtrl_GetCurSel(GetDlgItem(hDlg, TAB_BUTTON));
				for(int i = 0; i < 4 + SHOW_BUTTON_COUNT; i++){for(int j = 0; j < ASSIGN_COUNT_; j++){
					if(STATIC_ASSIGN[i][j] == selected){
						InvalidateRect(GetDlgItem(hDlg, selected), 0, FALSE);
						selected = 0;
						int id = ((i < 4) ? i : i + buttonTabNo * SHOW_BUTTON_COUNT) + padNo * (VC2_BTN1 - VC1_BTN1);
						assign_[id][j] = ((k == K_ESC) ? ID_DISABLE : static_cast<ButtonID>(k));
						SetDlgItemText(hDlg, STATIC_ASSIGN[i][j], BUTTON_NAME[assign_[id][j]]);
						WritePrivateProfileInt("Input", makeString("%s_%d", BUTTON_NAME[id + VC1_LEFT], j), assign_[id][j], iniFileName);
					}
				}}
			}
		}
		return FALSE;

	case WM_NOTIFY:
		switch(((NMHDR*)lParam)->code){
		case TCN_SELCHANGE:
			selected = 0;
			SendMessage(hDlg, WM_COMMAND, MAKELONG(COMBO_VC, CBN_CLOSEUP), 0);
			break;
		}
		return TRUE;

	case WM_COMMAND:
		if(LOWORD(wParam) >= 1000){
			switch(HIWORD(wParam)){
			case STN_CLICKED:
				if(HWND hwnd = GetDlgItem(hDlg, selected)) InvalidateRect(hwnd, 0, FALSE);
				selected = LOWORD(wParam);
				InvalidateRect((HWND)lParam, 0, FALSE);
				return TRUE;
			}
		}else{
			switch(LOWORD(wParam)){
			case COMBO_VC:
				if(HIWORD(wParam) == CBN_CLOSEUP){
					selected = 0;
					int padNo = (int)SendMessage(GetDlgItem(hDlg, COMBO_VC), CB_GETCURSEL, 0, 0);
					int buttonTabNo = TabCtrl_GetCurSel(GetDlgItem(hDlg, TAB_BUTTON));
					for(int i = 0; i < 4 + SHOW_BUTTON_COUNT; i++){
						int id = ((i < 4) ? i : i + buttonTabNo * SHOW_BUTTON_COUNT) + padNo * (VC2_BTN1 - VC1_BTN1);
						if(lstrlen(assignName_[id]) > 0){
							SetDlgItemText(hDlg, STATIC_BTN_NAME[i], makeString("%s", assignName_[id]));
							EnableWindow(GetDlgItem(hDlg, STATIC_BTN_NAME[i]), TRUE);
							for(int j = 0; j < ASSIGN_COUNT_; j++){
								EnableWindow(GetDlgItem(hDlg, STATIC_ASSIGN[i][j]), TRUE);
							}
						}else{
							static const char* DRCT[4] = {"Left", "Right", "Up", "Down"};
							SetDlgItemText(hDlg, STATIC_BTN_NAME[i], (i < 4) ? DRCT[i] : makeString("%d", i + buttonTabNo * SHOW_BUTTON_COUNT - 3));
							EnableWindow(GetDlgItem(hDlg, STATIC_BTN_NAME[i]), FALSE);
							for(int j = 0; j < ASSIGN_COUNT_; j++){
								EnableWindow(GetDlgItem(hDlg, STATIC_ASSIGN[i][j]), FALSE);
							}
						}
						for(int j = 0; j < ASSIGN_COUNT_; j++){
							SetDlgItemText(hDlg, STATIC_ASSIGN[i][j], BUTTON_NAME[assign_[id][j]]);
						}
					}
					SetFocus(GetDlgItem(hDlg, BUTTON_DUMMY));
					return TRUE;
				}
				break;

			case IDOK:
				KillTimer(hDlg, TIMER_PRESS);
				DeleteObject(brushSelected);
				DestroyWindow(hDlg);
				isDialogEnd_ = true;
				return TRUE;
			}
		}
		return FALSE;

	case WM_CTLCOLORSTATIC:
		if(GetDlgItem(hDlg, selected) == (HWND)lParam){
			SetTextColor((HDC)wParam, RGB(255, 255, 255));
			SetBkMode((HDC)wParam, TRANSPARENT);
			return (BOOL)brushSelected;
		}
		return FALSE;
	}
	return FALSE;
}

//========================================================================
void UQ::InputMgrImpl::showConfigurationDialog(HWND hWnd)
{
	HWND hDlg = CreateDialogParam(hInstance, MAKEINTRESOURCE(DIALOG_CONFIG), hWnd, (DLGPROC)::DlgProc, (LPARAM)this);
	if(!hDlg) return;
	ShowCursor(TRUE);
	SendMessage(hDlg, WM_COMMAND, MAKELONG(COMBO_VC, CBN_CLOSEUP), 0);

	while(!isDialogEnd_){
		System::getInstance()->doEvents();
		Sleep(16);
	}
	ShowCursor(FALSE);
}
*/