#pragma once

#include "common.h"
#include "../Include/InputMgr.h"

class CIniFileA;

namespace UQ{

class InputMgrImpl : public InputMgr{
public:
	InputMgrImpl();
	~InputMgrImpl();

	void update(void);
	bool isDown(ButtonID buttonID) const{return isDown_[buttonID];}
	bool isPressed(ButtonID buttonID) const{return (isDown_[buttonID] && !isDownPrev_[buttonID]);}
	bool isReleased(ButtonID buttonID) const{return (!isDown_[buttonID] && isDownPrev_[buttonID]);}
	void assign(
		ButtonID vcButtonID,
		const char* assignName,
		ButtonID assign1 = ID_DISABLE,
		ButtonID assign2 = ID_DISABLE,
		ButtonID assign3 = ID_DISABLE,
		ButtonID assign4 = ID_DISABLE
	);

	ButtonID J_LEFT(int padNo) const;
	ButtonID J_RIGHT(int padNo) const;
	ButtonID J_UP(int padNo) const;
	ButtonID J_DOWN(int padNo) const;
	ButtonID J_BTN(int padNo, int buttonNo) const;

	ButtonID VC_LEFT(int padNo) const;
	ButtonID VC_RIGHT(int padNo) const;
	ButtonID VC_UP(int padNo) const;
	ButtonID VC_DOWN(int padNo) const;
	ButtonID VC_BTN(int padNo, int buttonNo) const;

	const char* getButtonName(ButtonID buttonID);
	const char* getAssignName(ButtonID buttonID){return assignName_[buttonID - VC1_LEFT];}
	ButtonID getAssign(ButtonID buttonID, int assignNo){return assign_[buttonID - VC1_LEFT][assignNo];}
	void assign(ButtonID vcButtonID, int assignNo, ButtonID assign){assign_[vcButtonID - VC1_LEFT][assignNo] = assign;}
private:
	bool isDown_[BUTTON_ID_MAX];
	bool isDownPrev_[BUTTON_ID_MAX];
	char assignName_[VC_COUNT_ * (VC2_BTN1 - VC1_BTN1)][256];
	ButtonID assign_[VC_COUNT_ * (VC2_BTN1 - VC1_BTN1)][ASSIGN_COUNT_];
	SDL_Joystick* pJoystick_[J_COUNT_];
};

} // namespace UQ
