#pragma once

#include "common.h"
#include "../Include/MusicMgr.h"

namespace UQ{

class AudioMgrImpl;

class Music{
public:
	Music();
	~Music();

	bool open(const char* fileName);
	void play(bool isLooping);
	void stop(void);
	void pause(void);
	void resume(void);
	bool isPlaying(void) const;

private:
	Mix_Music* music_;
	enum{PLAYING, PAUSE, STOP} status_;
};


class MusicMgrImpl : public MusicMgr{
private:
	typedef std::shared_ptr<Music> MusicPtr;
	typedef std::map<int, MusicPtr> Musics;

public:
	MusicMgrImpl(AudioMgrImpl* pAudioMgr);
	~MusicMgrImpl();

	bool open(int id, const char* fileName);
	void close(int id);
	void play(int id, bool isLooping);
	void stop(void);
	void pause(void);
	void resume(void);
	bool isPlaying(void) const;
	void setVolume(float volume);
	void resetVolume(void){setVolume(volume_);}
private:
	AudioMgrImpl* pAudioMgr_;
	Musics musics_;
	Music* pCurrentMusic_;
	float volume_;
};

} // namespace UQ