#include "PCH.h"

#include "SoundMgrImpl.h"
#include "AudioMgrImpl.h"

//========================================================================
UQ::SoundMgrImpl::SoundMgrImpl(AudioMgrImpl* pAudioMgr) :
	pAudioMgr_(pAudioMgr),
	sounds_()
{
}

//========================================================================
UQ::SoundMgrImpl::~SoundMgrImpl()
{
}

//========================================================================
bool UQ::SoundMgrImpl::load(int id, const char* fileName)
{
	SoundPtr pSound = SoundPtr(new Sound());
	if(!pSound->load(fileName)){
		pSound = nullptr;
	}
	MY_VERIFY_EXPR(sounds_.insert(Sounds::value_type(id, pSound)).second, "w肳ꂽID͓o^ς݂łB");
	return (pSound != nullptr);
}

//========================================================================
void UQ::SoundMgrImpl::unload(int id)
{
	Sounds::iterator i = sounds_.find(id);
	MY_ASSERT_EXPR(i != sounds_.end(), "w肳ꂽID͓o^Ă܂B");
	sounds_.erase(id);
}

//========================================================================
void UQ::SoundMgrImpl::play(int id, float volume)
{
	Sounds::iterator i = sounds_.find(id);
	MY_ASSERT_EXPR(i != sounds_.end(), "w肳ꂽID͓o^Ă܂B");
	if(i->second) i->second->play(volume * pAudioMgr_->getVolume());
}

//========================================================================
//========================================================================
UQ::Sound::Sound() :
	chunk_(nullptr)
{
}

//========================================================================
UQ::Sound::~Sound()
{
	Mix_FreeChunk(chunk_);
}

//========================================================================
bool UQ::Sound::load(const char* fileName)
{
	chunk_ = Mix_LoadWAV(fileName);
	if(!chunk_) return false;
	return true;
}

//========================================================================
void UQ::Sound::play(float volume)
{
	Mix_VolumeChunk(chunk_, int(volume * 128));
	Mix_PlayChannel(-1, chunk_, 0);
}
