#pragma once

#include "common.h"
#include "../Include/SoundMgr.h"

namespace UQ{

class Sound{
public:
	Sound();
	~Sound();
	bool load(const char* fileName);
	void play(float volume);
private:
	Mix_Chunk *chunk_;
};

class AudioMgrImpl;

class SoundMgrImpl : public SoundMgr{
private:
	typedef std::shared_ptr<Sound> SoundPtr;
	typedef std::map<int, SoundPtr> Sounds;

public:
	SoundMgrImpl(AudioMgrImpl* pAudioMgr);
	~SoundMgrImpl();

	bool load(int id, const char* fileName);
	void unload(int id);
	void play(int id, float volume = 1.0f);

private:
	AudioMgrImpl* pAudioMgr_;
	Sounds sounds_;
};

} // namespace UQ
