#pragma once

#include "common.h"
#include "../Include/System.h"
#include <memory>

#define ASSERT_IS_INTIALIZED MY_ASSERT_EXPR(isInitialized_, "System Ă܂B")

class CIniFileA;

namespace UQ{

class GraphicMgr;
class AudioMgr;
class InputMgr;
class TaskMgr;

class GraphicMgrImpl;
class AudioMgrImpl;
class InputMgrImpl;
class TaskMgrImpl;

class SystemImpl : public System{
public:
	SystemImpl();
	~SystemImpl();

	void initialize(int windowWidth, int windowHeight, const char* windowTitle, const char* systemFontFileName, int systemFontWidth, int systemFontHeight);

	void run(void);
	void quit(void){ASSERT_IS_INTIALIZED; SDL_Event event = {SDL_QUIT}; SDL_PushEvent(&event);}

	unsigned int getFrameCount(void) const{return frameCount_;}

	void wait(int milliseconds);
	bool doEvents(void);

	GraphicMgr* getGraphicMgr(void) const;
	AudioMgr* getAudioMgr(void) const;
	InputMgr* getInputMgr(void) const;
	TaskMgr* getTaskMgr(void) const;

private:
	bool configureVolume(void);
	bool configureKey(void);

private:
	std::unique_ptr<GraphicMgrImpl> pGraphicMgr_;
	std::unique_ptr<AudioMgrImpl> pAudioMgr_;
	std::unique_ptr<InputMgrImpl> pInputMgr_;
	std::unique_ptr<TaskMgrImpl> pTaskMgr_;
	bool isInitialized_;
	unsigned int frameCount_;
};

} // namespace UQ