#pragma once

#include "common.h"
#include "../Include/TaskMgr.h"
#include <memory>

namespace UQ{

typedef std::shared_ptr<Task> TaskPtr;
enum Execution{UPDATE = 0, RENDER, EXECUTION_COUNT};

class TaskMgrImpl : public TaskMgr{
private:
	typedef std::list<TaskPtr> AllTasks; // Ԃ̍폜
	typedef std::vector<TaskPtr> EnumerationTasks; // _ANZXC
	typedef std::multimap<int, TaskPtr> ExecutionTasks;

public:
	TaskMgrImpl();
	~TaskMgrImpl();

	void clear(void);

	void executeAll(void);
	void optimize(void);

	void insertImpl(unsigned int type, Task* pTask, Task* pParent);
	unsigned int countImpl(unsigned int type) const;
	Task* enumerateImpl(unsigned int type, unsigned int index) const;

private:
	AllTasks allTasks_;
	std::vector<EnumerationTasks> enumerationTasks_;
	ExecutionTasks executionTasks_[EXECUTION_COUNT];
};

} // namespace UQ
