#pragma once

//========================================================================
// include
//========================================================================
#define _CRT_SECURE_NO_WARNINGS
#include <cstdio>
#include <cstdarg>
#include <cassert>
#include <cstring>
#include <vector>
#include <list>
#include <map>
#include <set>
#include <memory>

#include "inifile/inifile.h"

//========================================================================
// inline and global var
//========================================================================
namespace UQ{

inline std::string makeString(const char* format, ...)
{
	char buffer[1024] = "";
	va_list ap;
	va_start(ap, format);
	vsprintf(buffer, format, ap);
	va_end(ap);
	return std::string(buffer);
}
extern CIniFileA iniFile;
} // namespace UQ

//========================================================================
// ASSERT
//========================================================================
#ifdef NDEBUG
#	define MY_ASSERT_EXPR(expr, expr_str)
#	define MY_VERIFY_EXPR(expr, expr_str) (expr)
#else
#	define MY_ASSERT_EXPR(expr, expr_str) assert(expr && expr_str)
#	define MY_VERIFY_EXPR(expr, expr_str) MY_ASSERT_EXPR(expr, expr_str)
#endif

//========================================================================
// SDL
//========================================================================
#include "../SDK/SDL/Include/SDL.h"
#include "../SDK/SDL_mixer/Include/SDL_mixer.h"
#include "../SDK/SDL/Include/SDL_opengl.h"
#ifdef NDEBUG
#	pragma comment(lib, "SDK/SDL/Lib/SDL.lib")
#	pragma comment(lib, "SDK/SDL/Lib/SDLmain.lib")
#	pragma comment(lib, "SDK/SDL_mixer/Lib/SDL_mixer.lib")
#else
#	pragma comment(lib, "SDK/SDL/Lib/SDL_debug.lib")
#	pragma comment(lib, "SDK/SDL/Lib/SDLmain_debug.lib")
#	pragma comment(lib, "SDK/SDL_mixer/Lib/SDL_mixer_debug.lib")
#endif

#pragma comment(lib, "opengl32.lib")
#include "../SDK/glpng/Include/glpng.h"
#ifdef NDEBUG
#	pragma comment(lib, "SDK/glpng/Lib/glpng.lib")
#else
#	pragma comment(lib, "SDK/glpng/Lib/glpng_debug.lib")
#endif
