#pragma once

/**
@file
@brief OtBbN}l[W
@author m
*/

#include "Base.h"

namespace UQ{

/**
FNX.
At@FǗNXłB
*/
class Color{
public:
	Color() : color32bit_(0){}

	/**
	RXgN^.
	@param[in] color32bit	32bitJ[
	*/
	Color(unsigned long color32bit) : color32bit_(color32bit){}

	/**
	RXgN^.
	@param[in] a	At@
	@param[in] r	
	@param[in] g	
	@param[in] b	
	*/
	Color(unsigned char a, unsigned char r, unsigned char g, unsigned char b) : a_(a), r_(r), g_(g), b_(b){}

	/**
	ARGBݒ.
	@param[in] a	At@
	@param[in] r	
	@param[in] g	
	@param[in] b	
	*/
	void setARGB(unsigned char a, unsigned char r, unsigned char g, unsigned char b){a_ = a; r_ = r; g_ = g; b_ = b;}

	/**
	^ϊ.
	*/
	operator unsigned long() const{return color32bit_;}

	union{
		struct{
			unsigned char b_;	///< .
			unsigned char g_;	///< .
			unsigned char r_;	///< .
			unsigned char a_;	///< At@.
		};
		unsigned long color32bit_;	///< 32bit\L.
	};
};

/**
2xNgNX.
2xNgNXłBxy܂B
*/
template<typename T>
class Vector2DTemplate{
public:
	Vector2DTemplate() : x_(0), y_(0){}
	
	/**
	RXgN^.
	@param[in] x	x.
	@param[in] y	y.
	*/
	Vector2DTemplate(T x, T y) : x_(x), y_(y){}
	
	/**
	ݒ.
	@param[in] x	x.
	@param[in] y	y.
	*/
	void set(T x, T y){x_ = x; y_ = y;}

	Vector2DTemplate operator +() const{return *this;}
	Vector2DTemplate operator +(const Vector2DTemplate& v) const{return Vector2DTemplate(x_ + v.x_, y_ + v.y_);}
	Vector2DTemplate& operator +=(const Vector2DTemplate& v){x_ += v.x_; y_ += v.y_; return *this;}
	
	Vector2DTemplate operator -() const{return Vector2DTemplate(-x_, -y_);}
	Vector2DTemplate operator -(const Vector2DTemplate& v) const{return Vector2DTemplate(x_ - v.x_, y_ - v.y_);}
	Vector2DTemplate& operator -=(const Vector2DTemplate& v){x_ -= v.x_; y_ -= v.y_; return *this;}

	Vector2DTemplate operator *(const T t) const{return Vector2DTemplate(x_ * t, y_ * t);}
	Vector2DTemplate& operator *=(const T t){x_ *= t; y_ *= t; return *this;}

	Vector2DTemplate operator /(const T t) const{return Vector2DTemplate(x_ / t, y_ / t);}
	Vector2DTemplate& operator /=(const T t){x_ /= t; y_ /= t; return *this;}

	T x_; ///< X.
	T y_; ///< Y.
};

typedef Vector2DTemplate<float> Vector2D; ///< float^xNg.

/**
p`_NX.
Polygon p̒_NXłB
*/
class Vertex{
private:
	typedef Vector2DTemplate<int> TextureCoordinate; ///< eNX`Wpint^xNg.

public:
	Vertex() : vector_(), color_(0xFFFFFFFF), textureCoordinate_(){}

	Vector2D vector_;						///< _̈ʒuxNg.
	Color color_;							///< _̐F.
	TextureCoordinate textureCoordinate_;	///< eNX`W.
};

/**
p`NX.
p`NXłB Vertex ̔zێĂ܂B\n
pӂꂽ\bhȊȎ́Aoϐ𒼐ڕύXĂB\n
|S̗͕\܂BWύXۂ͒ӂĂB
*/
class DLL_EXPORT Polygon{
public:
	Polygon() : vertexCount_(0){}

	/**
	`.
	`ɃZbg܂B_̌4ɕύX܂B\n
	@param[in] x		xW
	@param[in] y		yW
	@param[in] width	
	@param[in] height	
	*/
	void setRectangle(int   x, int   y, int width, int height);
	void setRectangle(float x, float y, int width, int height);

	/**
	eNX`Wݒ.
	`iʂɂ͎lp`j4̒_ɑ΂āAeNX`Wݒ肵܂B\n
	setRectangle() ̌Ăяoɂ̊֐pƗLłB
	@param[in] x		xW
	@param[in] y		yW
	@param[in] width	
	@param[in] height	
	*/
	void setRectangleTexture(int x, int y, int width, int height);

	/**
	p`.
	p`ɃZbg܂B_̐nɕύX܂B\n
	( center.x_ + radius, center.y_ ) ̒_np`ɂȂ܂B
	@param[in] n		_̐inp`j
	@param[in] center	SW
	@param[in] radius	aiS璸_܂ł̋j
	*/
	void setRegularPolygon(int n, Vector2D center, float radius);

	/**
	Fݒ.
	SĂ̒_̐Fݒ肵܂B
	@param[in] color	F
	*/
	void setColor(Color color);

	/**
	sړ.
	sړ܂B
	@param[in] vector	ړxNg
	*/
	void translate(Vector2D vector);

	/**
	].
	]܂B
	@param[in] center	SʒuxNg
	@param[in] angle	pxiWAj
	*/
	void rotate(Vector2D center, float angle);

	/**
	gk.
	gk܂B
	@param[in] center	SʒuxNg
	@param[in] scaleX	x̊gl
	@param[in] scaleY	ẙgl
	*/
	void scale(Vector2D center, float scaleX, float scaleY);

	static const int VERTEX_COUNT_MAX_ = 128;	///< _̍ő.
#pragma warning(disable:4251)
	Vertex vertex_[VERTEX_COUNT_MAX_];	///< _.
#pragma warning(default:4251)
	int vertexCount_;	///<_̌.
};

/**
OtBbN}l[WNX.
`EeNX`̊ǗȂǂs܂B
*/
class GraphicMgr{
public:
	virtual ~GraphicMgr(){}

	/**
	wiF̐ݒ.
	wiFݒ肵܂B\n
	@param[in] color	wiF
	*/
	virtual void setBackgroundColor(Color color) = 0;
	
	/**
	|S`.
	Polygon ̏ɉă|S`悵܂B
	@param[in] polygon	|S
	*/
	virtual void drawPolygon(Polygon polygon) const = 0;

	/**
	eNX`ǂݍ.
	eNX`t@Cǂݍ݂܂B\n
	@param[in] id				eNX`ID
	@param[in] fileName			t@C
	@retval true ǂݍݐ
	@retval false ǂݍݎs
	*/
	virtual bool loadTexture(int id, const char* fileName) = 0;

	/**
	eNX`̉.
	w肵eNX`܂B
	@param[in] id	eNX`ID
	*/
	virtual void unloadTexture(int id) = 0;

	/**
	eNX`̃Zbg.
	w肵eNX`Zbg܂B\n
	@param[in] id	eNX`ID
	*/
	virtual void setTexture(int id) = 0;

	/**
	eNX`̃AZbg.
	݂̃eNX`AZbg܂B\n
	*/
	virtual void unsetTexture(void) = 0;

	/**
	eNX`̕擾.
	w肵eNX`̕擾܂B
	@param[in] id	eNX`ID
	@return eNX`̕
	*/
	virtual int getTextureWidth(int id) const = 0;

	/**
	eNX`̍擾.
	w肵eNX`̍擾܂B
	@param[in] id	eNX`ID
	@return eNX`̍
	*/
	virtual int getTextureHeight(int id) const = 0;

	/**
	fobOp`.
	fobOp̕`悵܂B\n
	@param[in] x		xW
	@param[in] y		yW
	@param[in] str		
	@param[in] color	F
	*/
	virtual void outputString(int x, int y, const char* str, Color color = 0xFFFFFFFF) = 0;
};

} // namespace UQ
