#pragma once

/**
@file
@brief VXe
@author m
*/

#include "Base.h"
#include <exception>

namespace UQ{

class GraphicMgr;
class AudioMgr;
class InputMgr;
class TaskMgr;

/**
VXeNX.
EBhEǗEe}l[W̊ǗȂǂs܂B\n
Singleton p^[ŎĂ܂B\n
N system.ini t@Cǂݍ݂܂B\n
system.ini t@Cɂ́AfBXvC[hE}X^[{[EL[RtBOۑĂ܂B\n
[F11]L[ƁAEBhE[h / tXN[[h̐؂ւs܂B
*/
class DLL_EXPORT System{
public:
	virtual ~System(){}

	/**
	CX^X̎擾.
	CX^X擾܂B\n
	̊֐߂ČĂяoꂽƂACX^X܂B
	*/
	static System* getInstance(void);

	/**
	CX^X̍폜.
	CX^X폜܂B\n
	IɕKĂяoĂB
	*/
	void deleteInstance(void);

	/**
	.
	܂BEBhEEe}l[W܂B\n
	@param[in] windowWidth			EBhE̕
	@param[in] windowHeight			EBhE̍
	@param[in] windowTitle			EBhẼ^Cg
	@param[in] systemFontFileName	VXetHg̃t@C
	@param[in] systemFontWidth		VXetHg̕
	@param[in] systemFontHeight		VXetHg̕
	*/
	virtual void initialize(int windowWidth, int windowHeight, const char* windowTitle, const char* systemFontFileName, int systemFontWidth, int systemFontHeight) = 0;

	/**
	C[v.
	֐Ń[v܂B quit() ̌Ăяoɂă[v𔲂܂B
	*/
	virtual void run(void) = 0;

	/**
	I.
	̊֐̌ĂяoɂAt[IɃ[v𔲂܂B
	*/
	virtual void quit(void) = 0;

	/**
	t[擾.
	C[vĂяȏt[擾܂B
	@return t[
	*/
	virtual unsigned int getFrameCount(void) const = 0;

	/**
	EFCg.
	w肵ԁA҂܂BŃbZ[Ws܂B
	@param[in] milliseconds	҂(ms)
	*/
	virtual void wait(int milliseconds) = 0;

	/**
	bZ[W.
	bZ[Ws܂B
	@retval true IbZ[W擾ĂȂ
	@retval false IbZ[W擾
	*/
	virtual bool doEvents(void) = 0;

	/**
	GraphicMgr IuWFNg̎擾.
	GraphicMgr IuWFNg擾܂B
	@return GraphicMgr IuWFNg̃|C^
	*/
	virtual GraphicMgr* getGraphicMgr(void) const = 0;
	
	/**
	AudioMgr IuWFNg̎擾.
	AudioMgr IuWFNg擾܂B
	@return AudioMgr IuWFNg̃|C^
	*/
	virtual AudioMgr* getAudioMgr(void) const = 0;
	
	/**
	InputMgr IuWFNg̎擾.
	InputMgr IuWFNg擾܂B
	@return InputMgr IuWFNg̃|C^
	*/
	virtual InputMgr* getInputMgr(void) const = 0;
	
	/**
	TaskMgr IuWFNg̎擾.
	TaskMgr IuWFNg擾܂B
	@return TaskMgr IuWFNg̃|C^
	*/
	virtual TaskMgr* getTaskMgr(void) const = 0;

private:
	static System* pSystem_;
};

/**
Oo.
*/
DLL_EXPORT void showError(const std::exception& ex);

} // namespace UQ
