#pragma once

/**
@file
@author m
*/

#include "Base.h"
#include "System.h"
#include "GraphicMgr.h"
#include "AudioMgr.h"
#include "SoundMgr.h"
#include "MusicMgr.h"
#include "InputMgr.h"
#include "TaskMgr.h"

#ifdef _MSC_VER
#	ifdef NDEBUG
#		pragma comment(lib, "UQGL.lib")
#	else
#		pragma comment(lib, "UQGL_debug.lib")
#	endif
#	pragma comment(linker, "/SUBSYSTEM:WINDOWS /ENTRY:mainCRTStartup")
#endif

namespace UQ{

inline System* getSystem(void){return System::getInstance();}								///< System IuWFNg̎擾.
inline GraphicMgr* getGM(void){return System::getInstance()->getGraphicMgr();}				///< GraphicMgr IuWFNg̎擾.
inline AudioMgr*   getAM(void){return System::getInstance()->getAudioMgr();}				///< AudioMgr IuWFNg̎擾.
inline SoundMgr*   getSM(void){return System::getInstance()->getAudioMgr()->getSoundMgr();}	///< SoundMgr IuWFNg̎擾.
inline MusicMgr*   getMM(void){return System::getInstance()->getAudioMgr()->getMusicMgr();}	///< MusicMgr IuWFNg̎擾.
inline InputMgr*   getIM(void){return System::getInstance()->getInputMgr();}				///< InputMgr IuWFNg̎擾.
inline TaskMgr*    getTM(void){return System::getInstance()->getTaskMgr();}					///< TaskMgr IuWFNg̎擾.

} // namespace UQ
